//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB42280244.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB42280244.cm

//## begin module%3EEB42280244.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB42280244.cp

//## Module: VModelDocumenter%3EEB42280244; Package body
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VModelDocumenter.cpp

//## begin module%3EEB42280244.additionalIncludes preserve=no
//## end module%3EEB42280244.additionalIncludes

//## begin module%3EEB42280244.includes preserve=yes
#include "UniRndGen.h"
#include "ExpRndGen.h"
#include "Modeling.h"
#include <iostream>
using namespace std;
//## end module%3EEB42280244.includes

// VModelDocumenter
#include "VModelDocumenter.h"
//## begin module%3EEB42280244.declarations preserve=no
//## end module%3EEB42280244.declarations

//## begin module%3EEB42280244.additionalDeclarations preserve=yes
//## end module%3EEB42280244.additionalDeclarations


// Class VisModelDocumenter 


//## Other Operations (implementation)
void VisModelDocumenter::visitModelElement (ModelElement* me, char* typeStr)
{
  //## begin VisModelDocumenter::visitModelElement%3EEF48C60140.body preserve=yes
	if (me==0) return;
	output("\n\n");
	writeNameType(me,typeStr);
	output();
	writeDescrLn(me);
  //## end VisModelDocumenter::visitModelElement%3EEF48C60140.body
}

void VisModelDocumenter::visitFlowElement (FlowElement* fe, char* typeStr)
{
  //## begin VisModelDocumenter::visitFlowElement%3EEF48F802E4.body preserve=yes
	if (fe==0) return;
	visitModelElement(fe,typeStr);
	output("Target: ");
	if (fe->target) {
		output("[ID="); 
		if (out) (*out)<<fe->target->getID()<<"] ";
		output(fe->target->getName());
	}
	output();
  //## end VisModelDocumenter::visitFlowElement%3EEF48F802E4.body
}

void VisModelDocumenter::visitUniformGenerator (UniformGenerator* e)
{
  //## begin VisModelDocumenter::visitUniformGenerator%3EEB1833023D.body preserve=yes
	if (e==0) return;
	output("Uniform random generator: ");
	output("Mean value = ");
	if (out) (*out)<<e->getMeanValue();
	output();
  //## end VisModelDocumenter::visitUniformGenerator%3EEB1833023D.body
}

void VisModelDocumenter::visitExpGenerator (ExpGenerator* e)
{
  //## begin VisModelDocumenter::visitExpGenerator%3EEB1833023F.body preserve=yes
	if (e==0) return;
	output("Exponential random generator: ");
	output("Mean value = ");
	if (out) (*out)<<e->getMeanValue();
	output();
  //## end VisModelDocumenter::visitExpGenerator%3EEB1833023F.body
}

void VisModelDocumenter::visitFlowSource (FlowSource* e)
{
  //## begin VisModelDocumenter::visitFlowSource%3EEB18330241.body preserve=yes
	visitFlowElement(e,"Flow Source");
	if (e->getRndGen()) e->getRndGen()->accept(this);
  //## end VisModelDocumenter::visitFlowSource%3EEB18330241.body
}

void VisModelDocumenter::visitFlowSink (FlowSink* e)
{
  //## begin VisModelDocumenter::visitFlowSink%3EEB18330243.body preserve=yes
	visitFlowElement(e,"Flow Sink");
  //## end VisModelDocumenter::visitFlowSink%3EEB18330243.body
}

void VisModelDocumenter::visitPipe (Pipe* e)
{
  //## begin VisModelDocumenter::visitPipe%3EEB18330245.body preserve=yes
	visitFlowElement(e,"Pipe");
	if (e->getRndGen()) e->getRndGen()->accept(this);
  //## end VisModelDocumenter::visitPipe%3EEB18330245.body
}

void VisModelDocumenter::visitQueuedServer (QueuedServer* e)
{
  //## begin VisModelDocumenter::visitQueuedServer%3EEB18330247.body preserve=yes
	visitFlowElement(e,"Queued Server");
	if (e->getRndGen()) e->getRndGen()->accept(this);
  //## end VisModelDocumenter::visitQueuedServer%3EEB18330247.body
}

void VisModelDocumenter::visitSwitch1to3 (Switch1to3* e)
{
  //## begin VisModelDocumenter::visitSwitch1to3%3EEB18330249.body preserve=yes
	visitFlowElement(e,"Switch 1 to 3");
	if (e->leftTarget && out) (*out)<<"Left turn target: "<<e->leftTarget->getID()<<"\n";
	if (out) (*out)<<"Left turn probability: "<<e->getLTProb()<<"\n";
	if (e->rightTarget && out) (*out)<<"Right turn target: "<<e->rightTarget->getID()<<"\n";
	if (out) (*out)<<"Right turn probability: "<<e->getRTProb()<<"\n";
  //## end VisModelDocumenter::visitSwitch1to3%3EEB18330249.body
}

void VisModelDocumenter::visitCrossSemaphore (CrossSemaphore* e)
{
  //## begin VisModelDocumenter::visitCrossSemaphore%3EEB1833026D.body preserve=yes
	visitModelElement(e,"Cross Semaphore");
	if (out) (*out)<<"Horizontal direction time: "<<e->getTimeHorizontal()<<"\n";
	if (out) (*out)<<"Vertical direction time: "<<e->getTimeVertical()<<"\n";
  //## end VisModelDocumenter::visitCrossSemaphore%3EEB1833026D.body
}

// Additional Declarations
  //## begin VisModelDocumenter%3EEB1833023A.declarations preserve=yes
  //## end VisModelDocumenter%3EEB1833023A.declarations

//## begin module%3EEB42280244.epilog preserve=yes
//## end module%3EEB42280244.epilog
