//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB419600C8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB419600C8.cm

//## begin module%3EEB419600C8.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB419600C8.cp

//## Module: VTxtOutputGen%3EEB419600C8; Package specification
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VTxtOutputGen.h

#ifndef VTxtOutputGen_h
#define VTxtOutputGen_h 1

//## begin module%3EEB419600C8.additionalIncludes preserve=no
//## end module%3EEB419600C8.additionalIncludes

//## begin module%3EEB419600C8.includes preserve=yes
#include "Visitor.h"
//## end module%3EEB419600C8.includes

//## begin module%3EEB419600C8.declarations preserve=no
//## end module%3EEB419600C8.declarations

//## begin module%3EEB419600C8.additionalDeclarations preserve=yes
#include<iostream>
using namespace std;

class ModelElement;
//## end module%3EEB419600C8.additionalDeclarations


//## begin VisTxtOutputGenerator%3EEB13C800D2.preface preserve=yes
//## end VisTxtOutputGenerator%3EEB13C800D2.preface

//## Class: VisTxtOutputGenerator%3EEB13C800D2; Abstract
//	Abstract genralization of Visitors that generate a
//	textual (sequential) output into an output stream.
//## Category: Traffic Modeling and Simulation::Visitors%3EEB0CA50186
//## Subsystem: Visitors%3EEB3A5302B2
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class VisTxtOutputGenerator : public Visitor  //## Inherits: <unnamed>%3EEB14F1008C
{
  //## begin VisTxtOutputGenerator%3EEB13C800D2.initialDeclarations preserve=yes
  //## end VisTxtOutputGenerator%3EEB13C800D2.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: output%3EEB1476010E
      //	Writes the given string to the output stream.
      virtual void output (char* str = "\n");

    // Additional Public Declarations
      //## begin VisTxtOutputGenerator%3EEB13C800D2.public preserve=yes
      //## end VisTxtOutputGenerator%3EEB13C800D2.public

  protected:
    //## Constructors (specified)
      //## Operation: VisTxtOutputGenerator%3EEB1437017C
      //	Constructor. Accepts an output stream.
      VisTxtOutputGenerator (ostream* outputStream);


    //## Other Operations (specified)
      //## Operation: writeNameType%3EEE07B5029E
      //	Writes the name and the type of the given Model Element.
      virtual void writeNameType (ModelElement* me, char* typeName);

      //## Operation: writeDescrLn%3EEE080B0208
      //	Writes "Description:\n" and then the description of the
      //	given Model Element. Puts a new line at the end.
      virtual void writeDescrLn (ModelElement* me);

    // Data Members for Class Attributes

      //## Attribute: out%3EEB1401014A
      //	The output stream.
      //## begin VisTxtOutputGenerator::out%3EEB1401014A.attr preserve=no  protected: ostream* {UA} outputStream
      ostream* out;
      //## end VisTxtOutputGenerator::out%3EEB1401014A.attr

    // Additional Protected Declarations
      //## begin VisTxtOutputGenerator%3EEB13C800D2.protected preserve=yes
      //## end VisTxtOutputGenerator%3EEB13C800D2.protected

  private:
    // Additional Private Declarations
      //## begin VisTxtOutputGenerator%3EEB13C800D2.private preserve=yes
      //## end VisTxtOutputGenerator%3EEB13C800D2.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin VisTxtOutputGenerator%3EEB13C800D2.implementation preserve=yes
      //## end VisTxtOutputGenerator%3EEB13C800D2.implementation

};

//## begin VisTxtOutputGenerator%3EEB13C800D2.postscript preserve=yes
//## end VisTxtOutputGenerator%3EEB13C800D2.postscript

// Class VisTxtOutputGenerator 

//## begin module%3EEB419600C8.epilog preserve=yes
//## end module%3EEB419600C8.epilog


#endif
